## ros-kinetic-canopen-chain-node 0.7.13

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(canopen_chain_node)

find_package(catkin REQUIRED
  COMPONENTS
    canopen_master
    diagnostic_updater
    message_generation
    pluginlib
    roscpp
    roslib
    socketcan_interface
    std_msgs
    std_srvs
)

find_package(Boost REQUIRED
  COMPONENTS
    filesystem
)

add_service_files(DIRECTORY srv
                  FILES
                  GetObject.srv
                  SetObject.srv)

generate_messages(DEPENDENCIES)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    canopen_ros_chain
  CATKIN_DEPENDS
    canopen_master
    diagnostic_updater
    message_runtime
    pluginlib
    roscpp
    socketcan_interface
    std_srvs
  DEPENDS
    Boost
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

# canopen_ros_chain
add_library(canopen_ros_chain
  src/ros_chain.cpp
)
target_link_libraries(canopen_ros_chain
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)
add_dependencies(canopen_ros_chain
  ${catkin_EXPORTED_TARGETS}
  ${${PROJECT_NAME}_EXPORTED_TARGETS}
)

# canopen_chain_node
add_executable(${PROJECT_NAME}
  src/chain_node.cpp
)
target_link_libraries(${PROJECT_NAME}
  canopen_ros_chain
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

# canopen_sync_node
add_executable(canopen_sync_node
  src/sync_node.cpp
)
target_link_libraries(canopen_sync_node
  ${Boost_LIBRARIES}
  ${catkin_LIBRARIES}
)

install(
  TARGETS
    ${PROJECT_NAME}
    canopen_ros_chain
    canopen_sync_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(
  DIRECTORY
    include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)

install(
  DIRECTORY
    launch
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

=== debian/changelog ===
ros-kinetic-canopen-chain-node (0.7.13-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 21 Aug 2020 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.12-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 03 Nov 2019 23:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.11-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sat, 13 Jul 2019 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.10-1xenial) xenial; urgency=high

  * require minimum version of class_loader and pluginlib
  * make sync_node return proper error codes
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 17 Mar 2019 23:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.9-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 May 2018 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.8-1xenial) xenial; urgency=high

  * Revert "pull make_shared into namespaces"
    This reverts commit 9b2cd05df76d223647ca81917d289ca6330cdee6.
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.7-1xenial) xenial; urgency=high

  * added types for all function objects
  * pull make_shared into namespaces
  * added types for all shared_ptrs
  * migrate to new classloader headers
  * address catkin_lint errors/warnings
  * removed IPC/SHM based sync masters
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.6-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 29 Aug 2017 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.5-1xenial) xenial; urgency=high

  * added reset_errors_before_recover option
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 28 May 2017 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.4-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.3-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.2-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.1-1xenial) xenial; urgency=high

  * refactored EMCY handling into separate layer
  * do not reset thread for recover
  * properly stop run thread if init failed
  * deprecation warning for SHM-based master implementations
  * implemented canopen_sync_node
  * wait only if sync is disabled
  * added object access services
  * implement level-based object logging
  * added node name lookup
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 19 Mar 2017 23:00:00 -0000

ros-kinetic-canopen-chain-node (0.7.0-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 12 Dec 2016 23:00:00 -0000

ros-kinetic-canopen-chain-node (0.6.5-1xenial) xenial; urgency=high

  * protect MotorChain setup with RosChain lock
  * added include to <boost/scoped_ptr.hpp>; solving #177 <https://github.com/ipa-mdl/ros_canopen/issues/177>
  * default to canopen::SimpleMaster::Allocator (#71 <https://github.com/ipa-mdl/ros_canopen/issues/71>)
  * exit code for generic error should be 1, not -1
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * moved roslib include into source file
  * renamed chain_ros.h to ros_chain.h, fixes #126 <https://github.com/ipa-mdl/ros_canopen/issues/126>
  * Use of catkin_EXPORTED_TARGETS
    Install target for canopen_ros_chain
  * Splitted charn_ros.h into chain_ros.h and ros_chain.cpp
  * Revert "stop heartbeat after stack was shutdown"
    This reverts commit de985b5e9664edbbcc4f743fff3e2a2391e1bf8f.
  * improve failure handling in init service callback
  * improved excetion handling in init and recover callback
  * Merge pull request #109 <https://github.com/ipa-mdl/ros_canopen/issues/109> from ipa-mdl/shutdown-crashes
    Fix for pluginlib-related crashes on shutdown
  * catch std::exception instead of canopen::Exception (#110 <https://github.com/ipa-mdl/ros_canopen/issues/110>)
  * call to detroy is not needed anymore
  * added GuardedClassLoader implementation
  * minor shutdown improvements
  * Contributors: Mathias Lüdtke, Michael Stoll, xaedes

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-kinetic-canopen-chain-node (0.6.4-1xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-kinetic-canopen-chain-node (0.6.3-1xenial) xenial; urgency=high

  * added motor_layer settings
  * remove boost::posix_time::milliseconds from SyncProperties
  * removed support for silence_us since bus timing cannot be guaranteed
  * implemented plugin-based Master allocators, defaults to LocalMaster
  * set initialized to false explicitly if init failed
  * include for std_msgs::String was missing
  * Merge remote-tracking branch 'origin/std_trigger' into new_402
    Conflicts:
    canopen_chain_node/CMakeLists.txt
    canopen_chain_node/include/canopen_chain_node/chain_ros.h
  * halt explicitly on shutdown
  * stop heartbeat after stack was shutdown
  * migrated to Timer instead of ros::Timer to send heartbeat even after ros was shutdown
  * run loop even if ros is shutdown
  * improved chain shutdown behaviour
  * fix for g++: proper message generation
  * Merge branch 'publisher' into muparser
    Conflicts:


=== debian/control ===
Source: ros-kinetic-canopen-chain-node
Section: misc
Priority: optional
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-kinetic-canopen-master, ros-kinetic-catkin, ros-kinetic-diagnostic-updater, ros-kinetic-message-generation, ros-kinetic-pluginlib (>= 1.11.2), ros-kinetic-roscpp, ros-kinetic-roslib, ros-kinetic-socketcan-interface, ros-kinetic-std-msgs, ros-kinetic-std-srvs
Homepage: http://wiki.ros.org/canopen_chain_node
Standards-Version: 3.9.2

Package: ros-kinetic-canopen-chain-node
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-canopen-master, ros-kinetic-diagnostic-updater, ros-kinetic-message-runtime, ros-kinetic-pluginlib (>= 1.11.2), ros-kinetic-roscpp, ros-kinetic-roslib, ros-kinetic-socketcan-interface, ros-kinetic-std-msgs, ros-kinetic-std-srvs
Description: Base implementation for CANopen chains node with support for management services and diagnostics

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/kinetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/kinetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/kinetic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-kinetic-canopen-chain-node//opt/ros/kinetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/kinetic/setup.sh" ]; then . "/opt/ros/kinetic/setup.sh"; fi && \
	dh_auto_install
